/*
Copyright 2016 Ian Jauslin

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
  Preprocessor macros for double arrays
*/


// reset CPP macros
#undef ARRAY_TYPENAME
#undef ARRAY_FUNC
#undef ARRAY_VAL_TYPE
#undef ARRAY_VAL_INIT
#undef ARRAY_VAL_FREE
#undef ARRAY_VAL_SET
#undef ARRAY_VAL_CPY
#undef ARRAY_VAL_IFEQ
#undef ARRAY_VAL_IFLT
#undef ARRAY_VAL_IFGT
#undef ARRAY_VAL_PRINT


// name of the polynomial type
#define ARRAY_TYPENAME array_double
// prefix of function names
#define ARRAY_FUNC(NAME) array_double_ ## NAME

// type of values
#define ARRAY_VAL_TYPE double
// set values
#define ARRAY_VAL_SET(VAL, NEWVAL) VAL = NEWVAL
// copy values
#define ARRAY_VAL_CPY(FROMVAL, TOVAL) TOVAL = FROMVAL
// compare values
#define ARRAY_VAL_IFEQ(VAL1, VAL2) VAL1==VAL2
#define ARRAY_VAL_IFLT(VAL1, VAL2) VAL1<VAL2
#define ARRAY_VAL_IFGT(VAL1, VAL2) VAL1>VAL2
// print values
#define ARRAY_VAL_PRINT(VAL) fprint_double(stdout, VAL)

