/*
Copyright 2016 Ian Jauslin

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
  Integration of real functions
*/

#ifndef LIBINUM_INTEGRAL_H
#define LIBINUM_INTEGRAL_H

#include "types.h"


//--------------------------------------------------
//
//  using doubles
//
//--------------------------------------------------
#include "integral_double.h"
#include "integral_base.h"


//--------------------------------------------------
//
//  using long doubles
//
//--------------------------------------------------
#include "integral_ldouble.h"
#include "integral_base.h"

//--------------------------------------------------
//
//  using mpfr floats
//
//--------------------------------------------------

#include "integral_mpfr.h"
#include "integral_base.h"

#endif
