/*
Copyright 2016 Ian Jauslin

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
  Types and structures
*/

#ifndef LIBINUM_TYPES_H
#define LIBINUM_TYPES_H

#include <mpfr.h>
#include <pthread.h>

// arrays
#include "array_int.h"
#include "array_type.h"

#include "array_uint.h"
#include "array_type.h"

#include "array_double.h"
#include "array_type.h"

#include "array_ldouble.h"
#include "array_type.h"

#include "array_mpfr.h"
#include "array_type.h"

#include "array_2_mpfr.h"
#include "array_type.h"

#include "array_char.h"
#include "array_type.h"

#include "array_str.h"
#include "array_type.h"

#include "array_pthread_t.h"
#include "array_type.h"


// 1-variable polynomial
#include "polynomial_mpfr.h"
#include "polynomial_type.h"

#include "polynomial_double.h"
#include "polynomial_type.h"

#include "polynomial_ldouble.h"
#include "polynomial_type.h"

// polynomial array
#include "array_polynomial_mpfr.h"
#include "array_type.h"

#include "array_polynomial_double.h"
#include "array_type.h"

#include "array_polynomial_ldouble.h"
#include "array_type.h"


// multivariable polynomials
#include "polynomialMV_mpz.h"
#include "polynomialMV_type.h"

#include "polynomialMV_int.h"
#include "polynomialMV_type.h"

#endif
