/*
Copyright 2016 Ian Jauslin

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
  Useful functions
*/

#ifndef LIBINUM_UTILS_H
#define LIBINUM_UTILS_H

#include <mpfr.h>
#include <stdio.h>

// print a double at maximal precision
int fprint_double(FILE* file, double x);
// print a long double at maximal precision
int fprint_ldouble(FILE* file, long double x);
// print an mpfr at maximal precision
int fprint_mpfr(FILE* file, mpfr_t x);

// print information about data types
int print_datatype_info();
#endif
